
namespace ToumeiHitsuji
{
    public partial class SlapStuff 
    {
        public static class Logger
        {
            public static bool DebugEnabled = false;
            public static string GeneralPrefix = $"[{nameof(SlapStuff)}] ";
            public static string DebugPrefix = $"[{nameof(SlapStuff)}][Debug] ";
            
            public static void LogDebugMessage<T>(T msg)
            {
                if (DebugEnabled)
                {
                    SuperController.LogMessage($"{DebugPrefix}{msg}");
                }
            }

            public static void LogDebugError<T>(T msg)
            {
                if (DebugEnabled)
                {
                    SuperController.LogError($"{DebugPrefix}{msg}");
                }
            }

            public static void LogMessage<T>(T msg)
            {
                SuperController.LogMessage($"{GeneralPrefix}{msg}");
            }

            public static void LogError<T>(T msg)
            {
                SuperController.LogError($"{GeneralPrefix}{msg}");
            }
        }
    }
}
