using System;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;
using System.Collections;

namespace ToumeiHitsuji
{

    public partial class SlapStuff
    {
        public class UIDynamicContainer
        {
            private MVRScript _parentScript = null;
            private List<UIDynamic> _uiElements = new List<UIDynamic>();
            public bool Empty { get {return _uiElements.Count == 0;}}

            public UIDynamicContainer(MVRScript parentScript)
            {
                _parentScript = parentScript;
            }

            public T Add<T>(T uiElement)
            {
                _uiElements.Add(uiElement as UIDynamic);
                return uiElement;
            }

            public void Clear()
            {
                foreach (UIDynamic uiElement in _uiElements)
                {
                    if (uiElement is UIDynamicButton)
                    {
                        _parentScript.RemoveButton(uiElement as UIDynamicButton);
                    }
                    else if(uiElement is UIDynamicSlider)
                    {
                        _parentScript.RemoveSlider(uiElement as UIDynamicSlider);
                    }
                    else if(uiElement is UIDynamicTextField)
                    {
                        _parentScript.RemoveTextField(uiElement as UIDynamicTextField);
                    }
                    else if(uiElement is UIDynamicToggle)
                    {
                        _parentScript.RemoveToggle(uiElement as UIDynamicToggle);
                    }
                    else if(uiElement is UIDynamicColorPicker)
                    {
                        _parentScript.RemoveColorPicker(uiElement as UIDynamicColorPicker);
                    }
                    else if(uiElement is UIDynamicPopup)
                    {
                        _parentScript.RemovePopup(uiElement as UIDynamicPopup);
                    }
                    else if(uiElement is UIDynamic)
                    {
                        _parentScript.RemoveSpacer(uiElement);
                    }
                }
                // do I also need to call Destroy on elements?
                _uiElements.Clear();
            }

            public void Show()
            {
                foreach (UIDynamic uiElement in _uiElements)
                {
                    uiElement.gameObject.SetActive(true);
                }
            }
            public void Hide()
            {
                foreach (UIDynamic uiElement in _uiElements)
                {
                    uiElement.gameObject.SetActive(false);
                }
            }
        }
    }

}
